<?php
include_once('interfaces/interface.DbAccessMethods.php');


final class DbAccessComp extends DbAccessBase implements DbAccessMethods
{
	private static $Instance;
	private $Link;
	private $Result;
	

	
	public static function Singleton() {
		if (!isset(self::$Instance)) {
			$ClassName = __CLASS__;
			self::$Instance = new $ClassName();
		}
		return self::$Instance;
	}	
	private function __clone() {}
	private function __construct() {
		$this->Connect();
		$this->SetFetchType(MYSQL_ASSOC);
		$this->SetEncoding('utf8');
	}	
	public function __destruct() {
		$this->FreeResult();
	}
	

	
	
	public function Query($Query) {
		$this->FreeResult();
		$this->Query = $Query;
		
		if (CONF_DEBUG_ENABLED) {
			$Debug = DebugLogger::Singleton();
			$Debug->StartQuery($Query);
		}
		
		$this->Result = mysql_query($Query, $this->Link);
		
		if (CONF_DEBUG_ENABLED) {
			$Num = is_resource($this->Result) ? $this->NumRows() : 0;
			$Aff = is_resource($this->Link) ? $this->AffectedRows() : 0;
			$Inf = is_resource($this->Link) ? $this->Info() : null;			
			$Debug->EndQuery($Num, $Aff, $Inf);
			if ($this->Result === false) $Debug->AddMessage(mysql_error($this->Link));
		}
		
		if ($this->Result === false) {
			trigger_error(mysql_error($this->Link), E_USER_ERROR);
			exit;
		}
	}
	
	
	

	public function FetchRow() {
		return mysql_fetch_array($this->Result, $this->FetchType);
	}

	public function FetchRows($KeyField=null, $ValueField=null) {
		$Result = array();
		while ($Row = mysql_fetch_array($this->Result, $this->FetchType)) {
			$Value = $ValueField ? $Row[$ValueField] : $Row;
			if ($KeyField) {
				$Result[$Row[$KeyField]] = $Value;
			} else {
				$Result[] = $Value;
			}
		}
		return $Result;
	}

	public function FetchCell($Field=0) {
		$Row = mysql_fetch_array($this->Result, MYSQL_BOTH);
		if ($Row===null) return null;
		return $Row[$Field];
	}
	
	public function FetchColumn($Field=0) {
		$Result = array();
		while ($Row = mysql_fetch_array($this->Result, MYSQL_BOTH)) {
			$Result[] = $Row[$Field];
		}
		return $Result;
	}

	public function FetchObject() {
		return mysql_fetch_object($this->Result);
	}

	public function FetchObjects() {
		$Result = array();
		while ($Result[] = mysql_fetch_object($this->Result));
		return $Result;		
	}	
	
	
	
	
	public function NumRows() {
		return mysql_num_rows($this->Result);
	}

	public function AffectedRows() {
		return mysql_affected_rows($this->Link);
	}
	
	public function InsertId() {
		return mysql_insert_id($this->Link);
	}

	public function Info() {
		return mysql_info($this->Link);
	}

	public function Stat() {
		return mysql_stat($this->Link);
	}
	
	public function FreeResult() {
		if (is_resource($this->Result)) {
			@mysql_free_result($this->Result);
		}
	}

	
	
	
	
	
	private function Connect() {
		$this->Link = mysql_connect(CONF_DBHOST, CONF_DBUSER, CONF_DBPASS);
		if (!$this->Link) {
			trigger_error('Cannot connect to database: '.mysql_error(), E_USER_ERROR);
			exit;
		}
		
		if (!mysql_select_db(CONF_DBNAME, $this->Link)) {
			trigger_error('Cannot select database: '.mysql_error($this->Link), E_USER_ERROR);
			exit;
		}
	}
}

?>