<?php

class GoogleRequester extends MultiRequester 
{	
	private $Request;
	private $Links;
	
	
	
	public function __construct($Request) {
		parent::__construct();
		$this->Request = $Request;
		$this->Links = array();
		$this->CreateRequesters();
	}
	
	public function Parse() {
		if ($this->Exec()) {
			foreach ($this->GetRequesters() as $Req) {
				if ($Req->IsOk()) {
					$Parser = new GoogleParser($Req->GetResult());
					$this->Links = array_merge($this->Links, $Parser->GetLinks());
				}
			}
			$this->Links = array_unique($this->Links);
			return $this->Links;
		}
		return false;		
	}
	
	public function Count() {
		return count($this->Links);
	}
	
	public function GetLinks() {
		return $this->Links;
	}
	
	
	
	
	
	private function CreateRequesters() {
		$Objects = array();
		for ($i=0; $i<1000; $i+=100) {
			$Req = new Requester('http://www.google.com/search?hl=en&start='.$i.'&num=100&q='.urlencode($this->Request));
			$this->AddRequester($Req);
		}
		$this->AddRequesters($Objects);
	}
}

?>