<?php
define('LOGFILE_MESSAGE', '>');
define('LOGFILE_SYSTEM', '$');
define('LOGFILE_OK', '+');
define('LOGFILE_ERROR', '-');
define('LOGFILE_WARNING', '!');



class LogFile
{
	private $FileName;
	private $FileHandle;
	private $Mute;
	
	
	/**
	* $FileName - name of file for append
	*/
	public function __construct($FileName) {
		$this->FileName = $FileName;
		$this->FileHandle = fopen(CONF_LOG_DIR.$FileName, 'ab+');
		$this->Mute = false;
		$this->Truncate();
	}
	
	public function __destruct() {
		fclose($this->FileHandle);
	}
	
	

	
	public function GetFileName() {
		return $this->FileName;
	}
	
	public function MuteOn() {
		$this->Mute = true;
	}
	
	public function MuteOff() {
		$this->Mute = false;
	}
	
	public function IsMute() {
		return $this->Mute;
	}
	
	

	public function AddMessage($Text) {
		$this->AddLog(LOGFILE_MESSAGE, $Text);
	}
	
	public function AddSystem($Text) {
		$this->AddLog(LOGFILE_SYSTEM, $Text);
	}

	public function AddOk($Text) {
		$this->AddLog(LOGFILE_OK, $Text);
	}

	public function AddError($Text) {
		$this->AddLog(LOGFILE_ERROR, $Text);
	}

	public function AddWarning($Text) {
		$this->AddLog(LOGFILE_WARNING, $Text);
	}

	public function AddLog($Type, $Text) {
		if ($this->Mute) return;
		$Mes = "[".date("d/H:i:s")." ".$Type."] ".$Text."\r\n";
		fwrite($this->FileHandle, $Mes);
		if (CONF_PRINT_LOGFILE_MESSAGES) echo $Mes;
	}
	
	public function Clear() {
		ftruncate($this->FileHandle, 0);
	}
	
	

	
	
	
	
	private function Truncate() {
		$Stat = fstat($this->FileHandle);
		if (CONF_LOGFILE_MAXSIZE
		&&	CONF_LOGFILE_MAXSIZE < $Stat['size']) {
			fseek($this->FileHandle, -CONF_LOGFILE_MAXSIZE, SEEK_END);
			$Content = fread($this->FileHandle, CONF_LOGFILE_MAXSIZE);
			ftruncate($this->FileHandle, 0);
			fwrite($this->FileHandle, $Content);
		}
	}
}

?>