<?php

abstract class Application
{
	protected $Dispatcher;
	protected $Skin;
	protected $db;
	
	
	

	public function __construct() {
		$this->Dispatcher = Dispatcher::Singleton();
		if (CONF_DEBUG_ENABLED) $this->Debug();
		$this->InitDb();
	}


	public function SetSkin(Skin $Skin) {
		$this->Skin = $Skin;
	}
	
	public function ProcessAction($ActionFile) {
		$this->CheckDemo();
		require($ActionFile);
	}
	
	public function IsPost() {
		return $_SERVER['REQUEST_METHOD'] == 'POST';
	}

	
	
	
	protected function InitDb() {
		$this->db = Db::Singleton();
	}
	
	protected function Debug($DebugFile=null) {
		$DebugFile = $DebugFile===null ?
			'debug.'.$this->Dispatcher->GetModuleName().'.'.$this->Dispatcher->GetActionName().'.srz'
		:	basename($DebugFile);
		$Debug = DebugLogger::Singleton();
		$Debug->SetFileName($DebugFile);
				
		if (empty($_SESSION['debug'])
		||	$_SESSION['debug']['ModuleName'] != $this->Dispatcher->GetModuleName()
		||	$_SESSION['debug']['ActionName'] != $this->Dispatcher->GetActionName()) {
			$Debug->Clear();
		}
		
		$Debug->AddMessage('GET: '.count($_GET).' items, POST: '.count($_POST).' items');
		
		$_SESSION['debug']['ModuleName'] = $this->Dispatcher->GetModuleName();
		$_SESSION['debug']['ActionName'] = $this->Dispatcher->GetActionName();
	}
	
	
	
	
	private function CheckDemo() {
		if (CONF_DEMO_VERSION && $this->IsPost()) {
			$this->Skin->AddError('_demo_version');
			$this->Dispatcher->Back();
		}
	}
}

?>