<?php
$this->Log->AddSystem('Checker started');
$DbProxy = new DbProxy();

while ($this->Process->GetTime() < CONF_PROC_DURATION)
{
	$this->Process->AddAction('checker');	
	
	// NEXT PORTION
	$Proxies = $DbProxy->GetNextPortion($this->Config->GetParam('check_portion'));
	if (empty($Proxies)) {
		$this->Log->AddMessage('All proxies is checked');
		$this->ResetGrabber();
		break;
	}

	// CHECK
	$Multi = new MultiRequester($Proxies);
	$Multi->Exec();
	$this->Log->AddSystem('Multirequest result: '.$Multi->GetStatusString());
	
	// PARSE
	foreach ($Proxies as $v) {
		$Worked = $v->Parse();
		$CurlHttp = 'CURL:'.$v->GetErrno().' '.$v->GetError().' HTTP:'.$v->GetHttpCode().' '.$v->GetHttpAnswer();
		if ($v->IsOk() && $Worked) 	$this->Log->AddOk('Worked: '.$v->GetProxy().' '.$CurlHttp);
		else 							$this->Log->AddMessage('Unworked: '.$v->GetProxy().' '.$CurlHttp);
	}

	// SAVE
	$DbProxy->Save();
}

$this->Log->AddSystem('Checker finished');
?>