<?php
$this->Log->AddSystem('Rechecker started');
$DbProxy = new DbProxy();

while ($this->Process->GetTime() < CONF_PROC_DURATION)
{
	$this->Process->AddAction('rechecker');
	
	// NEXT PORTION
	$Proxies = $DbProxy->GetNextPortion($this->Config->GetParam('recheck_portion'), true);
	if (empty($Proxies)) {
		$this->Log->AddMessage('No need for recheck at this moment');
		break;
	}
	
	// SET TIMEOUTS
	foreach ($Proxies as $v) {
		$v->SetOpt(CURLOPT_CONNECTTIMEOUT, $this->Config->GetParam('recheck_connect_timeout'));
		$v->SetOpt(CURLOPT_TIMEOUT, $this->Config->GetParam('recheck_request_timeout'));
	}

	// CHECK
	$Multi = new MultiRequester($Proxies);
	$Multi->Exec();
	$this->Log->AddSystem('Multirequest result: '.$Multi->GetStatusString());
	
	// PARSE
	$Unworked = array();
	foreach ($Proxies as $v) {
		$Worked = $v->Parse();
		$CurlHttp = 'CURL:'.$v->GetErrno().' '.$v->GetError().' HTTP:'.$v->GetHttpCode().' '.$v->GetHttpAnswer();
		if ($v->IsOk() && $Worked) $this->Log->AddOk('Worked: '.$v->GetProxy().' '.$CurlHttp);
		else {
			$this->Log->AddMessage('Unworked: '.$v->GetProxy().' '.$CurlHttp);
			$Unworked[] = $v;
		}
	}
	
	// RECHECK UNWORKED
	if (!empty($Unworked)) {
		$this->Process->AddAction('rechecker');
		$this->Log->AddMessage('Some proxies has been unworked - recheck again');
		
		$Multi = new MultiRequester($Unworked);
		$Multi->Exec();
		$this->Log->AddSystem('Multirequest result: '.$Multi->GetStatusString());

		// PARSE
		foreach ($Unworked as $v) {
			$Worked = $v->Parse();
			$CurlHttp = 'CURL:'.$v->GetErrno().' '.$v->GetError().' HTTP:'.$v->GetHttpCode().' '.$v->GetHttpAnswer();
			if ($v->IsOk() && $Worked)	$this->Log->AddOk('Worked: '.$v->GetProxy().' '.$CurlHttp);
			else						$this->Log->AddMessage('Unworked: '.$v->GetProxy().' '.$CurlHttp);
		}
	}

	// SAVE
	$DbProxy->Save(false); // do not delete unworked (move it to unchecked)
}

$this->Log->AddSystem('Rechecker finished');
?>